Index: trunk/src/wp-includes/comment-template.php
===================================================================
--- trunk/src/wp-includes/comment-template.php	(revision 33047)
+++ trunk/src/wp-includes/comment-template.php	(revision 33891)
@@ -38,29 +38,29 @@
 	 * @since 4.1.0 The `$comment_ID` and `$comment` parameters were added.
 	 *
+	 * @param string     $author     The comment author's username.
+	 * @param int        $comment_ID The comment ID.
+	 * @param WP_Comment $comment    The comment object.
+	 */
+	return apply_filters( 'get_comment_author', $author, $comment_ID, $comment );
+}
+
+/**
+ * Displays the author of the current comment.
+ *
+ * @since 0.71
+ *
+ * @param int $comment_ID Optional. The ID of the comment for which to print the author. Default current comment.
+ */
+function comment_author( $comment_ID = 0 ) {
+	$author = get_comment_author( $comment_ID );
+
+	/**
+	 * Filter the comment author's name for display.
+	 *
+	 * @since 1.2.0
+	 * @since 4.1.0 The `$comment_ID` parameter was added.
+	 *
 	 * @param string $author     The comment author's username.
 	 * @param int    $comment_ID The comment ID.
-	 * @param object $comment    The comment object.
-	 */
-	return apply_filters( 'get_comment_author', $author, $comment_ID, $comment );
-}
-
-/**
- * Displays the author of the current comment.
- *
- * @since 0.71
- *
- * @param int $comment_ID Optional. The ID of the comment for which to print the author. Default current comment.
- */
-function comment_author( $comment_ID = 0 ) {
-	$author = get_comment_author( $comment_ID );
-
-	/**
-	 * Filter the comment author's name for display.
-	 *
-	 * @since 1.2.0
-	 * @since 4.1.0 The `$comment_ID` parameter was added.
-	 *
-	 * @param string $author     The comment author's username.
-	 * @param int    $comment_ID The comment ID.
 	 */
 	echo apply_filters( 'comment_author', $author, $comment_ID );
@@ -84,7 +84,7 @@
 	 * @since 4.1.0 The `$comment_ID` and `$comment` parameters were added.
 	 *
-	 * @param string $comment_author_email The comment author's email address.
-	 * @param int    $comment_ID           The comment ID.
-	 * @param object $comment              The comment object.
+	 * @param string     $comment_author_email The comment author's email address.
+	 * @param int        $comment_ID           The comment ID.
+	 * @param WP_Comment $comment              The comment object.
 	 */
 	return apply_filters( 'get_comment_author_email', $comment->comment_author_email, $comment_ID, $comment );
@@ -171,6 +171,6 @@
 	 * @since 4.1.0 The `$comment` parameter was added.
 	 *
-	 * @param string $comment_author_email The comment author's email address.
-	 * @param object $comment              The comment object.
+	 * @param string     $comment_author_email The comment author's email address.
+	 * @param WP_Comment $comment              The comment object.
 	 */
 	$email = apply_filters( 'comment_email', $comment->comment_author_email, $comment );
@@ -251,7 +251,7 @@
 	 * @since 4.1.0 The `$comment_ID` and `$comment` parameters were added.
 	 *
-	 * @param string $comment_author_IP The comment author's IP address.
-	 * @param int    $comment_ID        The comment ID.
-	 * @param object $comment           The comment object.
+	 * @param string     $comment_author_IP The comment author's IP address.
+	 * @param int        $comment_ID        The comment ID.
+	 * @param WP_Comment $comment           The comment object.
 	 */
 	return apply_filters( 'get_comment_author_IP', $comment->comment_author_IP, $comment_ID, $comment );
@@ -290,7 +290,7 @@
 	 * @since 4.1.0 The `$comment_ID` and `$comment` parameters were added.
 	 *
-	 * @param string $url        The comment author's URL.
-	 * @param int    $comment_ID The comment ID.
-	 * @param object $comment    The comment object.
+	 * @param string     $url        The comment author's URL.
+	 * @param int        $comment_ID The comment ID.
+	 * @param WP_Comment $comment    The comment object.
 	 */
 	return apply_filters( 'get_comment_author_url', $url, $comment_ID, $comment );
@@ -509,5 +509,5 @@
 	 * @param string|int $date    Formatted date string or Unix timestamp.
 	 * @param string     $d       The format of the date.
-	 * @param object     $comment The comment object.
+	 * @param WP_Comment $comment The comment object.
 	 */
 	return apply_filters( 'get_comment_date', $date, $d, $comment );
@@ -564,7 +564,7 @@
 	 * @since 4.1.0 The `$comment_ID` and `$comment` parameters were added.
 	 *
-	 * @param string $excerpt    The comment excerpt text.
-	 * @param int    $comment_ID The comment ID.
-	 * @param object $comment    The comment object.
+	 * @param string     $excerpt    The comment excerpt text.
+	 * @param int        $comment_ID The comment ID.
+	 * @param WP_Comment $comment    The comment object.
 	 */
 	return apply_filters( 'get_comment_excerpt', $excerpt, $comment_ID, $comment );
@@ -612,6 +612,6 @@
 	 * @since 4.1.0 The `$comment_ID` parameter was added.
 	 *
-	 * @param int    $comment_ID The current comment ID.
-	 * @param object $comment    The comment object.
+	 * @param int        $comment_ID The current comment ID.
+	 * @param WP_Comment $comment    The comment object.
 	 */
 	return apply_filters( 'get_comment_ID', $comment->comment_ID, $comment );
@@ -637,6 +637,6 @@
  * @global bool       $in_comment_loop
  *
- * @param mixed $comment Comment to retrieve. Default current comment.
- * @param array $args    Optional. An array of arguments to override the defaults.
+ * @param WP_Comment|int|null $comment Comment to retrieve. Default current comment.
+ * @param array               $args    Optional. An array of arguments to override the defaults.
  * @return string The permalink to the given comment.
  */
@@ -682,7 +682,7 @@
 	 * @see get_page_of_comment()
 	 *
-	 * @param string $link    The comment permalink with '#comment-$id' appended.
-	 * @param object $comment The current comment object.
-	 * @param array  $args    An array of arguments to override the defaults.
+	 * @param string     $link    The comment permalink with '#comment-$id' appended.
+	 * @param WP_Comment $comment The current comment object.
+	 * @param array      $args    An array of arguments to override the defaults.
 	 */
 	return apply_filters( 'get_comment_link', $link, $comment, $args );
@@ -826,7 +826,7 @@
 	 * @see Walker_Comment::comment()
 	 *
-	 * @param string $comment_content Text of the comment.
-	 * @param object $comment         The comment object.
-	 * @param array  $args            An array of arguments.
+	 * @param string     $comment_content Text of the comment.
+	 * @param WP_Comment $comment         The comment object.
+	 * @param array      $args            An array of arguments.
 	 */
 	return apply_filters( 'get_comment_text', $comment->comment_content, $comment, $args );
@@ -854,7 +854,7 @@
 	 * @see Walker_Comment::comment()
 	 *
-	 * @param string $comment_text Text of the current comment.
-	 * @param object $comment      The comment object.
-	 * @param array  $args         An array of arguments.
+	 * @param string     $comment_text Text of the current comment.
+	 * @param WP_Comment $comment      The comment object.
+	 * @param array      $args         An array of arguments.
 	 */
 	echo apply_filters( 'comment_text', $comment_text, $comment, $args );
@@ -891,5 +891,5 @@
 	 * @param bool       $gmt       Whether the GMT date is in use.
 	 * @param bool       $translate Whether the time is translated.
-	 * @param object     $comment   The comment object.
+	 * @param WP_Comment $comment   The comment object.
 	 */
 	return apply_filters( 'get_comment_time', $date, $d, $gmt, $translate, $comment );
@@ -926,7 +926,7 @@
 	 * @since 4.1.0 The `$comment_ID` and `$comment` parameters were added.
 	 *
-	 * @param string $comment_type The type of comment, such as 'comment', 'pingback', or 'trackback'.
-	 * @param int 	 $comment_ID   The comment ID.
-	 * @param object $comment      The comment object.
+	 * @param string     $comment_type The type of comment, such as 'comment', 'pingback', or 'trackback'.
+	 * @param int 	     $comment_ID   The comment ID.
+	 * @param WP_Comment $comment      The comment object.
 	 */
 	return apply_filters( 'get_comment_type', $comment->comment_type, $comment_ID, $comment );
@@ -1859,8 +1859,8 @@
 	 * @see wp_list_comments()
 	 *
-	 * @param string $output  Passed by reference. Used to append additional content.
-	 * @param object $comment The comment object. Default current comment.
-	 * @param int    $depth   Depth of comment.
-	 * @param array  $args    An array of arguments.
+	 * @param string     $output  Passed by reference. Used to append additional content.
+	 * @param WP_Comment $comment The comment object. Default current comment.
+	 * @param int        $depth   Depth of comment.
+	 * @param array      $args    An array of arguments.
 	 */
 	public function end_el( &$output, $comment, $depth = 0, $args = array() ) {
@@ -1885,7 +1885,7 @@
 	 * @see wp_list_comments()
 	 *
-	 * @param object $comment The comment object.
-	 * @param int    $depth   Depth of comment.
-	 * @param array  $args    An array of arguments.
+	 * @param WP_Comment $comment The comment object.
+	 * @param int        $depth   Depth of comment.
+	 * @param array      $args    An array of arguments.
 	 */
 	protected function ping( $comment, $depth, $args ) {
@@ -2049,5 +2049,5 @@
  *     @type bool   $echo              Whether to echo the output or return it. Default true.
  * }
- * @param array $comments Optional. Array of comment objects.
+ * @param array $comments Optional. Array of WP_Comment objects.
  */
 function wp_list_comments( $args = array(), $comments = null ) {